unsigned int crc_ccitt (unsigned int iCRC, const unsigned char cData)
{
unsigned char c=8;
	asm volatile (	"mov __tmp_reg__, %2\r\n"
					"crc_ccitt_loop:\r\n"
					"lsl %3\r\n"
					"rol %A0\r\n"
					"rol %B0\r\n"
					"brcc crc_ccitt_next\r\n"
					"ldi %2, 0x10\r\n"
					"eor %B0, %2\r\n"
					"ldi %2, 0x21\r\n"
					"eor %A0, %2\r\n"
					"crc_ccitt_next:\r\n"
					"dec __tmp_reg__\r\n"
					"brne crc_ccitt_loop\r\n"
					:"=r" (iCRC)
					: "0" (iCRC), "a" (c), "r" (cData)
					);
	return (iCRC);
}

bool crc_ccitt_check (const unsigned char *p, const unsigned char cLen)
{
unsigned int crc=0;
unsigned char c;
	for (c=0; c<cLen; c++)
		crc = crc_ccitt (crc, p[c]);
	if (crc == 0)
		return true;
	else
		return false;
}

void crc_ccitt_update (unsigned char *p, const unsigned char cLen)
{
unsigned int crc=0;
unsigned char c;
	for (c=0; c<cLen-2; c++)
		crc = crc_ccitt (crc, p[c]);

	crc = crc_ccitt (crc, 0);
	crc = crc_ccitt (crc, 0);

	p[cLen-2] = (uint8_t)(crc>>8);
	p[cLen-1] = (uint8_t)(crc);
}

// Liefert Anzahl der Einsen im binren Muster von c
unsigned char weight (unsigned char c)
{
unsigned char ret;
	asm volatile (	"mov __tmp_reg__, %1\r\n"
					"clr %0\r\n"
					"weight_loop:\r\n"
					"rol __tmp_reg__\r\n"
					"adc %0, __zero_reg__\r\n"
					"tst __tmp_reg__\r\n"
					"brne weight_loop\r\n"
					:"=r" (ret)			// output
					:"r" (c)			// input
					);
	return (ret);
}
